function love.load()
	blocksa = {}
	for x = 1, 400 do
		blocksa[x] = {['x'] = math.random(0, 800)}
		blocksa[x]['y'], blocksa[x]['size'], blocksa[x]['speed'], blocksa[x]['r'], blocksa[x]['g'], blocksa[x]['b'] = makeblock()
	end
	blocksb = {}
	for x = 1, 250 do
		blocksb[x] = {['x'] = math.random(0, 800)}
		blocksb[x]['y'], blocksb[x]['size'], blocksb[x]['speed'], blocksb[x]['r'], blocksb[x]['g'], blocksb[x]['b'] = makeblock()
	end
	extrawidth = 0
end

function love.update(dt)
	mousex, mousey = love.mouse.getPosition()
	if love.mouse.isDown('l') then
		extrawidth = extrawidth + (75 * dt)
		if extrawidth > 25 then extrawidth = 25 end
	elseif love.mouse.isDown('r') then
		extrawidth = extrawidth - (75 * dt)
		if extrawidth < -25 then extrawidth = -25 end
	else
		if extrawidth > 0.1 then extrawidth = extrawidth - (16 * dt)
		elseif extrawidth < -0.1 then extrawidth = extrawidth + (16 * dt)
		else extrawidth = 0 end
	end
end

function makeblock()
	-- y, size, speed, r, g, b
	return math.random(-50, 490), math.random(16, 32), math.random(64, 128), math.random() * 32, math.random() * 32, math.random() * 32
end

function love.draw()
	delt = love.timer.getDelta()
	love.graphics.setBlendMode('additive')
	for x = 1, #blocksa do
		blocksa[x]['x'] = blocksa[x]['x'] - (blocksa[x]['speed'] * delt)
		if blocksa[x]['x'] < -blocksa[x]['size'] then
			blocksa[x]['x'] = 800
			blocksa[x]['y'], blocksa[x]['size'], blocksa[x]['speed'], blocksa[x]['r'], blocksa[x]['g'], blocksa[x]['b'] = makeblock()
		end
		blockr = blocksa[x]['r'] * (mousex / 100.5)
		blockg = blocksa[x]['g'] * (mousex / 100.5)
		blockb = blocksa[x]['b'] * (mousex / 100.5)
		love.graphics.setColor(blockr, blockg, blockb, 255)
		love.graphics.rectangle('fill', blocksa[x]['x'], blocksa[x]['y'], blocksa[x]['size'] + extrawidth, blocksa[x]['size'] * 8)
	end
	love.graphics.setBlendMode('subtractive')
	for x = 1, #blocksb do
		blocksb[x]['x'] = blocksb[x]['x'] + (blocksb[x]['speed'] * delt)
		if blocksb[x]['x'] > 800 then
			blocksb[x]['y'], blocksb[x]['size'], blocksb[x]['speed'], blocksb[x]['r'], blocksb[x]['g'], blocksb[x]['b'] = makeblock()
			blocksb[x]['x'] = -blocksb[x]['size']* 8
		end
		blockr = blocksb[x]['r'] * (mousey / 62.81)
		blockg = blocksb[x]['g'] * (mousey / 62.81)
		blockb = blocksb[x]['b'] * (mousey / 62.81)
		love.graphics.setColor(blockr, blockg, blockb, 255)
		love.graphics.rectangle('fill', blocksb[x]['x'], blocksb[x]['y'], blocksb[x]['size'] * 8, blocksb[x]['size'] + extrawidth)
	end
end

function love.keypressed(key)
	love.event.push('quit')
end